package net.t2code.t2codelib.BUNGEE.api.bungeePlayers;


import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.event.PlayerDisconnectEvent;
import net.md_5.bungee.api.event.PluginMessageEvent;
import net.md_5.bungee.api.event.PostLoginEvent;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.event.EventHandler;
import net.t2code.t2codelib.BUNGEE.api.messages.T2CB_Send;
import net.t2code.t2codelib.BUNGEE.system.T2CB_Main;
import net.t2code.t2codelib.SPIGOT.api.bungeePlayers.T2C_BngeePlayersEnum;
import net.t2code.t2codelib.util.T2C_Util;

import java.io.*;
import java.util.logging.Logger;

public class T2CB_BungeePlayers implements Listener {

    @EventHandler
    public void onJoin(PostLoginEvent e) {
        sendToSpigotPlayer(e.getPlayer().getName(), T2C_BngeePlayersEnum.JOIN, "");
    }

    @EventHandler
    public void onDisconnect(PlayerDisconnectEvent e) {
        sendToSpigotPlayer(e.getPlayer().getName(), T2C_BngeePlayersEnum.QUIT, "");
    }

    public static void sendToSpigotPlayer(String name, T2C_BngeePlayersEnum value, String uuid) {
        switch (value) {
            case JOIN:
            case QUIT:
                sendToSpigotPlayerExecute(name, value, uuid);
                break;
            case GIVEALL:
                StringBuilder input = new StringBuilder();
                for (ProxiedPlayer player : ProxyServer.getInstance().getPlayers()) {
                    input.append(player.getName()).append(";");
                }
                sendToSpigotPlayerExecute(input.toString(), T2C_BngeePlayersEnum.GIVEALL, uuid);
                break;
        }
    }

    private static void sendToSpigotPlayerExecute(String name, T2C_BngeePlayersEnum value, String uuid) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF(value.name());
            output.writeUTF(name);
            output.writeUTF(uuid);
        } catch (IOException e) {
            Logger.getLogger(e.getMessage());
        }
        T2CB_Send.debug(T2CB_Main.getPlugin(), "PluginMessage received channel: "+ T2C_Util.getPluginChannel_ProxyOnlinePlayers());
        T2CB_Send.debug(T2CB_Main.getPlugin(), "PluginMessage received subChannel: " + value.name());
        T2CB_Send.debug(T2CB_Main.getPlugin(), "PluginMessage received input: " + name);
        T2CB_Send.debug(T2CB_Main.getPlugin(), "PluginMessage received input2/uuid: " + uuid);
        ProxyServer.getInstance().getServers().values().stream().forEach((server) -> {
            server.sendData(T2C_Util.getPluginChannel_ProxyOnlinePlayers(), stream.toByteArray());
        });
    }

    public static void sendToSpigotDeleteAll() {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF(T2C_BngeePlayersEnum.CLEAR.name());
            output.writeUTF("");
            output.writeUTF("");
        } catch (IOException e) {
            Logger.getLogger(e.getMessage());
        }
        ProxyServer.getInstance().getServers().values().stream().forEach((server) -> {
            server.sendData(T2C_Util.getPluginChannel_ProxyOnlinePlayers(), stream.toByteArray());
        });
    }

    @EventHandler
    public void onPluginMessage(PluginMessageEvent event) {
        if (event.getTag().equalsIgnoreCase(T2C_Util.getPluginChannel_ProxyOnlinePlayers())) {
            DataInputStream stream = new DataInputStream(new ByteArrayInputStream(event.getData()));
            event.setCancelled(true);
            try {
                T2C_BngeePlayersEnum subChannel = T2C_BngeePlayersEnum.valueOf(stream.readUTF());
                String input = stream.readUTF();

                T2CB_Send.debug(T2CB_Main.getPlugin(), "PluginMessage received channel: " + event.getTag());
                T2CB_Send.debug(T2CB_Main.getPlugin(), "PluginMessage received subChannel: " + subChannel.name());
                T2CB_Send.debug(T2CB_Main.getPlugin(), "PluginMessage received input/uuid: " + input);

                sendToSpigotPlayer("", subChannel, input);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
