package net.t2code.t2codelib.BUNGEE.api.update;

import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.plugin.Plugin;
import net.t2code.t2codelib.BUNGEE.api.messages.T2CB_Send;
import net.t2code.t2codelib.BUNGEE.system.config.T2CB_LibConfig;
import net.t2code.t2codelib.util.T2C_UpdateObject;
import net.t2code.t2codelib.util.T2C_UpdateWebData;
import net.t2code.t2codelib.util.T2C_UpdateType;

import java.util.HashMap;
import java.util.concurrent.TimeUnit;

public class T2CB_UpdateAPI {
    public static HashMap<String, T2C_UpdateObject> bungeePluginVersins = new HashMap<>();

    public static void sendUpdateMsg(String prefix, String discord, T2C_UpdateWebData webData, Plugin plugin, CommandSender sender) {
        String publicVersion = webData.getVersion();
        String pluginVersion = plugin.getDescription().getVersion();
        String value;
        if (webData.isPreRelease()) {
            value = T2C_UpdateType.PRERELEASE.text;
            if (publicVersion.toLowerCase().contains("dev")) {
                value = T2C_UpdateType.DEVELOPMENT.text;
            }
            if (publicVersion.toLowerCase().contains("beta")) {
                value = T2C_UpdateType.BETA.text;
            }
            if (publicVersion.toLowerCase().contains("snapshot")) {
                value = T2C_UpdateType.SNAPSHOT.text;
            }
        } else value = T2C_UpdateType.STABLE.text;
        String h = "<br><dark_red>╔══════════════</dark_red>" + prefix + "<dark_red>══════════════</dark_red>";
        String s1 = "<br><dark_red>║</dark_red> <gold>A new [value] version was found!</gold>".replace("[value]", value);
        String s2 = "<br><dark_red>║</dark_red> <gold>Your version: <red>" + pluginVersion + "</red> <gray>-</gray> Current version:</gold> <green>" + webData.getVersion() + "</green>";
        String s3 = "<br><dark_red>║</dark_red> <gold>You can download it here:</gold> <yellow>" + webData.getUpdateUrl() + "</yellow>";
        String s4 = "<br><dark_red>║</dark_red> <gold>You can find more information on Discord:</gold> <yellow>" + discord + "</yellow>";
        String f = "<br><dark_red>╚══════════════</dark_red>" + prefix + "<dark_red>══════════════</dark_red>";
        String text = h + s1 + s2 + s3 + s4 + f;
        if (sender == null) {
            T2CB_Send.console(text);
        } else T2CB_Send.sender(sender, text);

    }

    private static Boolean noUpdate = true;
    private static String pluginVersion;

    public static void onUpdateCheckTimer(Plugin plugin, String prefix, String discord, Integer spigotID, String url) {
        if ((int) T2CB_LibConfig.VALUES.updateTimer.getValue() < 1) {
            T2CB_LibConfig.VALUES.updateTimer.setValue(1);
        }
        ProxyServer.getInstance().getScheduler().schedule(plugin, new Runnable() {
            public void run() {
                (new T2CB_UpdateCheckerGit(plugin)).getVersion((webData) -> {
                    pluginVersion = plugin.getDescription().getVersion();
                    T2C_UpdateObject update = new T2C_UpdateObject(
                            plugin.getDescription().getName(),
                            plugin.getDescription().getVersion(),
                            webData,
                            false,
                            !plugin.getDescription().getVersion().equals(webData.getVersion()),
                            true
                    );
                    bungeePluginVersins.put(plugin.getDescription().getName(), update);
                    if (!pluginVersion.replace("_Bungee", "").equalsIgnoreCase(webData.getVersion())) {
                        sendUpdateMsg(prefix, discord, webData, plugin, null);
                        noUpdate = true;
                    } else {
                        if (noUpdate) {
                            T2CB_Send.console(prefix + " §2No update found.");
                            noUpdate = false;
                        }
                    }
                }, pluginVersion, spigotID, url);
            }
        }, 0, (int) T2CB_LibConfig.VALUES.updateTimer.getValue() * 60 * 20L, TimeUnit.SECONDS);
    }
}
