package net.t2code.t2codelib.BUNGEE.api.update;

import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.plugin.Plugin;
import net.t2code.t2codelib.BUNGEE.system.config.T2CB_LibConfig;
import net.t2code.t2codelib.util.T2C_UpdateObject;
import net.t2code.t2codelib.util.T2C_UpdateWebData;
import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.function.Consumer;

public class T2CB_UpdateCheckerGit {
    private Plugin plugin;


    public T2CB_UpdateCheckerGit(Plugin plugin) {
        this.plugin = plugin;

    }

    public void getVersion(Consumer<T2C_UpdateWebData> consumer, String pluginVersion, Integer spigotID, String gitKey) {
        String RepoURL = "https://git.t2code.net/api/v1/repos/" + gitKey + "/releases?limit=1";
        if (!(boolean) T2CB_LibConfig.VALUES.seePreReleaseUpdates.getValue() ) {
            RepoURL = RepoURL + "&pre-release=false";
        }
        String finalRepoURL = RepoURL;
        ProxyServer.getInstance().getScheduler().runAsync(this.plugin, () -> {
            try {
                URL url = new URL(finalRepoURL);
                URLConnection yc = url.openConnection();
                BufferedReader in = new BufferedReader(
                        new InputStreamReader(
                                yc.getInputStream()));
                String inputLine;
                String data = "";
                while ((inputLine = in.readLine()) != null)
                    data = inputLine;
                in.close();
                data = data.substring(1, data.length() - 1);
                if (data.isEmpty()) {
                    consumer.accept(null);
                    return;
                }
                JSONObject obj = new JSONObject(data);
                String updateTitle = obj.getString("name");
                String version = obj.getString("tag_name");
                String updateDescription = obj.getString("body").replace("\n", "<br>").replace("\r", "").replace("'", "''");
                String updateUrl = obj.getString("html_url");
                boolean preRelease = obj.getBoolean("prerelease");

                String date = obj.getString("published_at");
                SimpleDateFormat inputFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
                SimpleDateFormat outputFormat = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss a");
                Date parsedDate = inputFormat.parse(date);
                String publishedAt = outputFormat.format(parsedDate);

                JSONArray downloadArray = obj.getJSONArray("assets");
                String gitURL = updateUrl;
                String downloadURL;
                if (downloadArray.isEmpty()) {
                    downloadURL = "https://www.spigotmc.org/resources/" + spigotID;
                } else {
                    downloadURL = downloadArray.getJSONObject(0).getString("browser_download_url");
                }

                if (!preRelease) {
                    downloadURL = "https://www.spigotmc.org/resources/" + spigotID;
                    updateUrl = "https://www.spigotmc.org/resources/" + spigotID;
                }

                T2C_UpdateWebData webData = new T2C_UpdateWebData(updateTitle, version, updateDescription, updateUrl, publishedAt, downloadURL, gitURL, preRelease);
                consumer.accept(webData);
            } catch (Exception var10) {
                Boolean load = false;
                if (T2CB_UpdateAPI.bungeePluginVersins.containsKey(plugin.getDescription().getName())) {
                    load = T2CB_UpdateAPI.bungeePluginVersins.get(plugin.getDescription().getName()).load;
                }
                T2C_UpdateObject update = new T2C_UpdateObject(
                        plugin.getDescription().getName(),
                        pluginVersion,
                        null,
                        load,
                        false,
                        true
                );
                T2CB_UpdateAPI.bungeePluginVersins.put(plugin.getDescription().getName(), update);
                this.plugin.getLogger().severe("§4 Cannot look for updates: " + var10.getMessage());
            }
        });
    }
}
