package net.t2code.t2codelib.BUNGEE.system;

import lombok.Getter;
import net.kyori.adventure.platform.bungeecord.BungeeAudiences;
import net.md_5.bungee.api.plugin.Plugin;
import net.t2code.t2codelib.BUNGEE.api.messages.T2CB_Send;
import net.t2code.t2codelib.BUNGEE.api.bungeePlayers.T2CB_BungeePlayers;
import net.t2code.t2codelib.BUNGEE.api.pluginMessaging.T2CB_PluginMessageProxyCommand;
import net.t2code.t2codelib.BUNGEE.api.pluginMessaging.autoResponse.T2CB_API_AutoResponse;
import net.t2code.t2codelib.BUNGEE.api.pluginMessaging.commandgui.T2CB_API_CGUI;
import net.t2code.t2codelib.BUNGEE.api.pluginMessaging.opSecurity.T2CB_API_OpSecurity;
import net.t2code.t2codelib.BUNGEE.api.update.T2CB_UpdateAPI;
import net.t2code.t2codelib.BUNGEE.system.bstats.T2CB_Metrics;
import net.t2code.t2codelib.BUNGEE.system.config.T2CB_LibConfig;
import net.t2code.t2codelib.util.T2C_PlatformDetector;
import net.t2code.t2codelib.util.T2C_Util;

public class T2CB_Main extends Plugin {

    @Getter
    private static Plugin plugin;

    private static String version;
    private static String orgVersion;
    private static String autor;

    private static Boolean mmIsLoad = true;
    private static BungeeAudiences adventure;

    public static BungeeAudiences getAdventure() {
        T2C_PlatformDetector.scan();
        if (adventure == null) {
            throw new IllegalStateException("Cannot retrieve audience provider while plugin is not enabled");
        }
        return adventure;
    }


    @Override
    public void onEnable() {
        // Plugin startup logic
        plugin = this;
        orgVersion = plugin.getDescription().getVersion();
        autor = plugin.getDescription().getAuthor();
        try {
            adventure = BungeeAudiences.create(this);
            T2CB_Send.info(this, "Adventure load!");
        } catch (Exception e) {
            T2CB_Send.error(this, "Adventure can not be load!");
            mmIsLoad = false;
        }
        onLoad(T2C_Util.getPrefix(), autor, orgVersion, T2C_Util.getSpigot(), T2C_Util.getDiscord(), T2C_Util.getSpigotID(), T2C_Util.getBstatsID(), T2C_Util.getGit());
        version = plugin.getDescription().getVersion();
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
        T2CB_BungeePlayers.sendToSpigotDeleteAll();
        if (mmIsLoad) {
            if (adventure != null) {
                adventure.close();
                adventure = null;
            }
        }
        T2CB_Send.console(T2C_Util.getPrefix() + "§4============================= " + T2C_Util.getPrefix() + " §4=============================");
        T2CB_Send.console(T2C_Util.getPrefix() + " §2Autor: §6" + String.valueOf(plugin.getDescription().getAuthor()).replace("[", "").replace("]", ""));
        T2CB_Send.console(T2C_Util.getPrefix() + " §2Version: §6" + version);
        T2CB_Send.console(T2C_Util.getPrefix() + " §2Spigot: §6" + T2C_Util.getSpigot());
        T2CB_Send.console(T2C_Util.getPrefix() + " §2Discord: §6" + T2C_Util.getDiscord());
        T2CB_Send.console(T2C_Util.getPrefix() + " §4Plugin successfully disabled.");
        T2CB_Send.console(T2C_Util.getPrefix() + "§4============================= " + T2C_Util.getPrefix() + " §4=============================");
    }

    public static Boolean getMmIsLoad() {
        return mmIsLoad;
    }

    public static void onLoad(String prefix, String autor, String version, String spigot, String discord, Integer spigotID, Integer bstatsID, String url) {
        long long_ = System.currentTimeMillis();
        T2CB_Send.console(prefix + "§4============================= " + prefix + " §4=============================");
        T2CB_Send.console(prefix + " §2Autor: §6" + String.valueOf(autor).replace("[", "").replace("]", ""));
        T2CB_Send.console(prefix + " §2Version: §6" + version);
        T2CB_Send.console(prefix + " §2Spigot: §6" + spigot);
        T2CB_Send.console(prefix + " §2Discord: §6" + discord);

        T2CB_Metrics.bStats(plugin, bstatsID);
        T2CB_LibConfig.set();

        T2CB_UpdateAPI.onUpdateCheckTimer(plugin, prefix, discord, spigotID, url);

        //API
        plugin.getProxy().registerChannel(T2C_Util.getPluginChannel_ProxyCommand());
        plugin.getProxy().getPluginManager().registerListener(plugin, new T2CB_PluginMessageProxyCommand());

        plugin.getProxy().registerChannel(T2C_Util.getPluginChannel_ProxyOnlinePlayers());
        plugin.getProxy().getPluginManager().registerListener(plugin, new T2CB_BungeePlayers());
        T2CB_BungeePlayers.sendToSpigotDeleteAll();

        if ((boolean) T2CB_LibConfig.VALUES.apiCommandGUIEnable.getValue()) {
            plugin.getProxy().registerChannel(T2C_Util.getPluginChannel_CGUIOnlinePlayers());
            plugin.getProxy().getPluginManager().registerListener(plugin, new T2CB_API_CGUI());
            T2CB_API_CGUI.sendToSpigotDeleteAll();
        }
        if ((boolean) T2CB_LibConfig.VALUES.apiAutoResponse.getValue()) {
            plugin.getProxy().registerChannel(T2C_Util.getPluginChannel_AutoResponse());
            plugin.getProxy().getPluginManager().registerListener(plugin, new T2CB_API_AutoResponse());
        }
        if ((boolean) T2CB_LibConfig.VALUES.apiOpSecurity.getValue()) {
            plugin.getProxy().registerChannel(T2C_Util.getPluginChannel_OPSecurity());
            plugin.getProxy().getPluginManager().registerListener(plugin, new T2CB_API_OpSecurity());
        }

        T2CB_Send.console(prefix + " §2Plugin loaded successfully." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
        T2CB_Send.console(prefix + "§4============================= " + prefix + " §4=============================");
    }
}
