package net.t2code.t2codelib.BUNGEE.system.config;

import net.t2code.t2codelib.BUNGEE.api.yaml.T2CB_ConfigWriter;
import net.t2code.t2codelib.BUNGEE.system.T2CB_Main;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import net.t2code.t2codelib.util.T2C_Util;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

public class T2CB_LibConfig {

    public enum VALUES implements T2C_ConfigItem {
        updateTimer("updateCheck.timerInMin", 60, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of("In this option you can set the time interval in minutes in which updates should be checked."));
                }}),
        seePreReleaseUpdates("updateCheck.seePreReleaseUpdates", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of("In this option you can set whether you want to receive and display beta and snapshot versions in the update check."));
                }}),

        apiCommandGUIEnable("api.commandGUI.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of("With this option you activate the api interface for the T2C-CommandGUI plugin."));
                }}),
        apiAutoResponse("api.autoResponse.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of("With this option you activate the api interface for the T2C-AutoResponse plugin."));
                }}),
        apiOpSecurity("api.opSecurity.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of("With this option you activate the api interface for the T2C-OPSecurity plugin."));
                }}),
        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return null;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set() {
        try {
            ConvertT2CBlibConfig.convert();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        T2CB_ConfigWriter.createConfig(new File(T2CB_Main.getPlugin().getDataFolder(), "config.yml"), VALUES.values(), T2C_Util.getConfigLogo());
    }

}
