package net.t2code.t2codelib.SPIGOT.api.messages;

import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.util.T2C_GenerateFrame;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class T2C_Send {

    public static void sendStartTextCenter(String prefix, String text, boolean isReload) {
        if (isReload) {
            console(prefix + " " + text);
            return;
        }
        console(T2C_GenerateFrame.setCenterAligned(prefix, text));
    }

    public static void sendStartTextLeft(String prefix, String text, boolean isReload) {
        if (isReload) {
            console(prefix + " " + text);
            return;
        }
        console(T2C_GenerateFrame.setLeftAligned(prefix, text));
    }

    public static String getFrameCenter(String prefix, boolean console, String... lines) {
        return T2C_GenerateFrame.getFrameCenter(prefix, console, lines);
    }

    public static String getFrameLeft(String prefix, boolean console, String... lines) {
        return T2C_GenerateFrame.getFrameLeft(prefix, console, lines);
    }

    public static void sendException(Exception e, Logger logger) {
        logger.log(Level.SEVERE, "Interrupted exception occurred", e);
    }

    public static void console(String msg) {
        if (msg == null || msg.contains("[empty]")) return;
        T2C_MiniMessage.sendConsoleMiniMessage(msg);
    }

    public static void player(Player player, String msg) {
        if (msg == null || msg.contains("[empty]")) return;
        T2C_MiniMessage.sendPlayerMiniMessage(msg, player);
    }

    public static void sender(CommandSender sender, String msg) {
        if (msg == null || msg.contains("[empty]")) return;
        T2C_MiniMessage.sendSenderMiniMessage(msg, sender);
    }

    public static void console(Object object) {
        for (String msg : list(object)) {
            if (msg == null || msg.contains("[empty]")) continue;
            T2C_MiniMessage.sendConsoleMiniMessage(msg);
        }
    }

    public static void player(Player player, Object object) {
        for (String msg : list(object)) {
            if (msg == null || msg.contains("[empty]")) continue;
            T2C_MiniMessage.sendPlayerMiniMessage(msg, player);
        }
    }


    public static void sender(CommandSender sender, Object object) {
        for (String msg : list(object)) {
            if (msg == null || msg.contains("[empty]")) return;
            T2C_MiniMessage.sendSenderMiniMessage(msg, sender);
        }
    }

    public static void title(Player player, @Nullable String title, @Nullable String subtitle) {
        player.sendTitle(title, subtitle);
    }

    public static void title(Player player, @Nullable String title, @Nullable String subtitle, int fadeIn, int stay, int fadeOut) {
        player.sendTitle(title, subtitle, fadeIn, stay, fadeOut);
    }

    /**
     * @deprecated This method will be removed soon, as the debug messages have been moved to a separate class.
     * Please use the new method {@link T2C_Debug#debug(Plugin, String)} or {@link T2C_Debug#debug(Plugin, String, Integer)}
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void debug(Plugin plugin, String msg) {
        debug(plugin, msg, null);
    }

    /**
     * @deprecated This method will be removed soon, as the debug messages have been moved to a separate class.
     * Please use the new method {@link T2C_Debug#debug(Plugin, String)} or {@link T2C_Debug#debug(Plugin, String, Integer)}
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void debug(Plugin plugin, String msg, Integer stage) {
        //  if (!new File(Main.getPath(), "config.yml").exists()) return;
        T2C_Debug.debug(plugin, msg, stage);
    }

    /**
     * @deprecated This method will be removed soon, as the debug messages have been moved to a separate class.
     * Please use the new method {@link T2C_Debug#debugmsg(Plugin, String)}
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void debugmsg(Plugin plugin, String msg) {
        T2C_Debug.debugmsg(plugin, msg);
    }

    public static void info(Plugin plugin, String msg) {
        plugin.getLogger().log(Level.INFO, msg);
    }

    public static void warning(Plugin plugin, String msg) {
        plugin.getLogger().log(Level.WARNING, msg);
    }

    public static void error(Plugin plugin, String msg) {
        plugin.getLogger().log(Level.SEVERE, msg);
    }

    private static ArrayList<String> list(Object object) {
        ArrayList<String> list = new ArrayList<>();

        if (object instanceof List) {
            list = (ArrayList<String>) object;
        }
        if (object instanceof String) {
            list.add((String) object);
        }
        return list;
    }
}
