package net.t2code.t2codelib.SPIGOT.api.yaml;

import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Replace;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import net.t2code.t2codelib.SPIGOT.api.sound.T2C_Sound;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import org.bukkit.Sound;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.inventory.ItemStack;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class T2C_Config {

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, String value, YamlConfiguration YamlConfiguration) {
        if (!YamlConfiguration.contains(path)) {
            YamlConfiguration.set(path, value);
        }
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, Object value, YamlConfiguration YamlConfiguration) {
        if (!YamlConfiguration.contains(path)) {
            YamlConfiguration.set(path, value);
        }
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, YamlConfiguration YamlConfiguration) {
        YamlConfiguration.set(path, null);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, Integer value, YamlConfiguration YamlConfiguration) {
        if (!YamlConfiguration.contains(path)) {
            YamlConfiguration.set(path, value);
        }
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, Double value, YamlConfiguration YamlConfiguration) {
        if (!YamlConfiguration.contains(path)) {
            YamlConfiguration.set(path, value);
        }
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, Boolean value, YamlConfiguration YamlConfiguration) {
        if (!YamlConfiguration.contains(path)) {
            YamlConfiguration.set(path, value);
        }
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, List<String> value, YamlConfiguration YamlConfiguration) {
        if (!YamlConfiguration.contains(path)) {
            YamlConfiguration.set(path, value);
        }
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void set(String path, ItemStack value, YamlConfiguration YamlConfiguration) {
        if (!YamlConfiguration.contains(path)) {
            YamlConfiguration.set(path, value);
        }
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void setSound(String soundName, String sound1_8, String sound1_9, String sound1_13, YamlConfiguration yamlConfiguration) {
        set("Sound." + soundName + ".Enable", true, yamlConfiguration);
        String sound;
        if (T2C_McVersion.isMc1_8()) {
            sound = sound1_8.toString();
        } else if (T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
            sound = sound1_9.toString();
        } else sound = sound1_13.toString();
        set("Sound." + soundName + ".Sound", sound, yamlConfiguration);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void setSound(String soundName, String sound1_8, String sound1_13, YamlConfiguration yamlConfiguration) {
        set("Sound." + soundName + ".Enable", true, yamlConfiguration);
        String sound;
        if (T2C_McVersion.isMc1_8()) {
            sound = sound1_8.toString();
        } else sound = sound1_13.toString();
        set("Sound." + soundName + ".Sound", sound, yamlConfiguration);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void setSound(String soundName, String sound, YamlConfiguration yamlConfiguration) {
        set("Sound." + soundName + ".Enable", true, yamlConfiguration);
        set("Sound." + soundName + ".Sound", sound.toString(), yamlConfiguration);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static boolean selectSoundEnable(String soundName, YamlConfiguration yamlConfiguration) {
        return selectBoolean("Sound." + soundName + ".Enable", yamlConfiguration);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static String selectSound(String prefix, String soundName, YamlConfiguration yamlConfiguration) {
        return select(prefix, "Sound." + soundName + ".Sound", yamlConfiguration);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static Sound checkSound(String sound1_8, String sound1_9, String sound1_13, String selectSoundFromConfig, String prefix) {
        return T2C_Sound.checkSound(sound1_8, sound1_9, sound1_13, selectSoundFromConfig, prefix);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static Sound checkSound(String sound1_8, String sound1_13, String selectSoundFromConfig, String prefix) {
        return T2C_Sound.checkSound(sound1_8, sound1_13, selectSoundFromConfig, prefix);
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static Sound checkSound(String sound, String selectSoundFromConfig, String prefix) {
        return T2C_Sound.checkSound(sound, selectSoundFromConfig, prefix);

    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static String select(String prefix, String path, YamlConfiguration yamlConfiguration) {
        return T2C_Replace.replace(prefix, yamlConfiguration.getString(path));
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static Object selectObject(String prefix, String path, YamlConfiguration yamlConfiguration) {
        return T2C_Replace.replaceObject(prefix, yamlConfiguration.get(path));
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static Integer selectInt(String path, YamlConfiguration yamlConfiguration) {
        return (yamlConfiguration.getInt(path));
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static Boolean selectBoolean(String path, YamlConfiguration yamlConfiguration) {
        return (yamlConfiguration.getBoolean(path));
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static Double selectDouble(String path, YamlConfiguration yamlConfiguration) {
        return (yamlConfiguration.getDouble(path));
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static List<String> selectList(String path, YamlConfiguration yamlConfiguration) {
        return (yamlConfiguration.getStringList(path));
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static ItemStack selectItemStack(String path, YamlConfiguration yamlConfiguration) {
        return (yamlConfiguration.getItemStack(path));
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static List<String> selectList(String prefix, String path, YamlConfiguration yamlConfiguration) {
        List<String> output = new ArrayList<>();
        List<String> input = yamlConfiguration.getStringList(path);
        for (String st : input) {
            output.add(T2C_Replace.replace(prefix, st));
        }
        return output;
    }

    /**
     * @deprecated since version 16.7
     * This method will be removed soon!
     * Please use the new {@link T2C_ConfigWriter#createConfig(File, T2C_ConfigItem[], String...)}.
     */
    @Deprecated(since = "16.7", forRemoval = true)
    public static void select(String prefix, List<String> value, String path, YamlConfiguration yamlConfiguration) {
        List<String> output = new ArrayList<>();
        List<String> input = yamlConfiguration.getStringList(path);
        for (String st : input) {
            output.add(T2C_Replace.replace(prefix, st));
        }
        value = output;
    }
}
