// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.api.yaml;

import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import net.t2code.t2codelib.util.T2C_ConfigItemLanguages;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.*;

public class T2C_LanguageWriter {

    private static FileConfiguration config;

    public static void createConfig(String prefix, File path, T2C_ConfigItemLanguages[] values, String loadConfig, boolean isReload, String... header) {

        File f = new File(path + "/languages/");
        f.mkdirs();
        File[] fileArray = f.listFiles();
        if (fileArray.length == 0) {
            List<File> zw = new ArrayList<>();
            for (T2C_LanguageEnum lan : T2C_LanguageEnum.values()) {
                if (values[0].getLanguage().containsKey(lan)) {
                    zw.add(new File(path + "/languages/" + lan.name() + ".yml"));
                }
            }
            fileArray = zw.toArray(new File[0]);
        }
        for (File langFile : fileArray) {
            if (langFile.getName().endsWith(".yml")) {
                T2C_LanguageEnum lang = T2C_LanguageEnum.english;
                try {
                    lang = T2C_LanguageEnum.valueOf(langFile.getName().replace(".yml", ""));
                } catch (Exception ignore) {
                }

                if (!langFile.exists()) {
                    langFile.getParentFile().mkdirs();
                    try {
                        langFile.createNewFile();
                    } catch (IOException e) {
                        T2C_Send.sendException(e, T2C_Main.getPlugin().getLogger());
                        return;
                    }
                }
                Map<String, List<String>> comments = new LinkedHashMap<>();
                // Copy default values if they are missing
                config = YamlConfiguration.loadConfiguration(langFile);
                config.options().copyDefaults(true);
                for (T2C_ConfigItemLanguages item : values) {
                    config.addDefault(item.getPath(), item.getLanguage().get(lang));


                    List<String> commandList = item.getComments().get(lang);
                    if (commandList != null) {
                        comments.put(item.getPath(), commandList);
                    }
                }
                T2C_YmlWriter.saveConfigWithComments(langFile, config, comments, true, header);
            }
        }
        readConfig(prefix, path, values, loadConfig, isReload);
    }

    private static void readConfig(String prefix, File path, T2C_ConfigItemLanguages[] values, String loadConfig, boolean isReload) {
        String selectMSG;
        File msg;
        msg = new File(path, "languages/" + loadConfig + ".yml");
        if (!msg.isFile()) {
            T2C_Send.sendStartTextCenter(prefix, "", isReload);
            T2C_Send.sendStartTextCenter(prefix, "§4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", isReload);
            T2C_Send.sendStartTextCenter(prefix, "§4The selected §c" + loadConfig + " §4language file was not found.", isReload);
            T2C_Send.sendStartTextCenter(prefix, "§6The default language §e" + T2C_LanguageEnum.english.name() + " §6is used!", isReload);
            T2C_Send.sendStartTextCenter(prefix, "§4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", isReload);
            T2C_Send.sendStartTextCenter(prefix, "", isReload);
            msg = new File(path, "languages/" + T2C_LanguageEnum.english.name() + ".yml");
            selectMSG = T2C_LanguageEnum.english.name();
        } else selectMSG = loadConfig;
        YamlConfiguration yml = YamlConfiguration.loadConfiguration(msg);
        for (T2C_ConfigItemLanguages value : values) {
            value.setValue(yml.get(value.getPath()));
        }
        T2C_Send.sendStartTextCenter(prefix, "§2Language successfully selected to: §6" + selectMSG, isReload);
    }
}
