// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.system.config.languages;


import lombok.NonNull;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import net.t2code.t2codelib.util.T2C_ConfigItemLanguages;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_LanguageWriter;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_Util;

import java.util.*;

public class T2CLibLanguages {

    public enum VALUES implements T2C_ConfigItemLanguages {
        otherLang("plugin", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, null);
                    put(T2C_LanguageEnum.english, null);
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Wenn du eine Eigene Sprache hinzufügen magst, dann kopiere einfach eine Sprachdatei und benenne sie in deine Sprache, dies kannst du dann in der config.yml einstellen.", ""));
                    put(T2C_LanguageEnum.english, List.of("If you want to add your own language, simply copy a language file and rename it to your language, you can then set this in config.yml.", ""));
                }}),

        vaultNotSetUp("plugin.vaultNotSetUp",
                null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] &4Vault / Economy nicht eingerichtet!"));
                    put(T2C_LanguageEnum.english,List.of( "[prefix] &4Vault / Economy not set up!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Diese Meldung wird angezeigt, wenn ein Plugin auf die Vault Schnittstelle von T2CodeLib zugreift und Vault oder kein Economy System vorhanden ist."));
                    put(T2C_LanguageEnum.english, List.of("This message is displayed if a plugin accesses the Vault interface of T2CodeLib and Vault or no Economy System is available."));
                }}),

        votingPluginNotSetUp("plugin.votingPluginNotSetUp",
                null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] &4VotingPlugin ist auf dem Server nicht vorhanden!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] &4VotingPlugin is not present on the server!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Diese Meldung wird angezeigt, wenn ein Plugin auf die VotingPlugin Schnittstelle von T2CodeLib zugreift und VotingPlugin nicht vorhanden ist.", "VotingPlugin: https://spigotmc.org/resources/votingplugin.15358/"));
                    put(T2C_LanguageEnum.english, List.of("This message is displayed if a plugin accesses the VotingPlugin interface of T2CodeLib and VotingPlugin is not available.", "VotingPlugin: https://spigotmc.org/resources/votingplugin.15358/"));
                }}),
        soundNotFound("plugin.soundNotFound",
                null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] &4Der Sound &6[sound] &4wurde nicht gefunden! Bitte überprüfe die Einstellungen."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] &4The sound &6[sound] &4was not found! Please check the settings."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Diese Meldung wird angezeigt, wenn ein Sound über die T2CodeLib abgespielt werden soll, den es nicht gibt."));
                    put(T2C_LanguageEnum.english, List.of("This message is displayed if a sound is to be played via the T2CodeLib that does not exist."));
                }}),

        ;

        private final String path;
        private Object value;
        private final HashMap<T2C_LanguageEnum, List<String>> lang;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, @NonNull HashMap<T2C_LanguageEnum, List<String>> lang, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2C_LanguageEnum.english);
            }
            return value;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        T2C_LanguageWriter.createConfig(T2C_Util.getPrefix(), T2C_Main.getPath(), VALUES.values(), T2C_LibConfig.VALUES.language.getValue().toString(), isReload, T2C_Util.getConfigLogo());

    }
}