package net.t2code.t2codelib.util;


import java.util.HashMap;
import java.util.List;

public interface T2C_ConfigItem {
    /**
     * Returns the path of the option for the config
     * @return Config path of the option
     */
    String getPath();

    /**
     * Returns the default value of the option and, after reading the config, the value from the config
     * @return Value of the option
     */
    Object getValue();

    /**
     * Here you determine whether the value should always be set (true) or only when the config is first created (false)
     */
    boolean getForceSet();

    /**
     * Set the description of the option here, the '# ' is automatically set in front of it
     */
    HashMap<T2C_LanguageEnum,List<String>> getComments();


    String getLanguagePath();

    /**
     * This @void is used to reset the value of @getValue()
     */
    default void setValue(Object newValue){

    }

}
