package net.t2code.t2codelib.util;

import lombok.Getter;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class T2C_Util {

    @Getter
    private static String infoText = "<yellow>Description:</yellow> <gold>[getDescription()]</gold>";

    @Getter
    private static String prefix = "<dark_gray>[<dark_red>T2Code</dark_red><dark_purple>Lib</dark_purple>]</dark_gray>";

    @Getter
    private static String vPrefix = "[T2CodeLib]";

    @Getter
    private static Integer spigotID = 96388;

    @Getter
    private static String git = "JaTiTV/T2CodeLib";

    @Getter
    private static Integer bstatsID = 12518;

    @Getter
    private static String spigot = "https://spigotmc.org/resources/" + getSpigotID();

    @Getter
    private static String discord = "http://dc.t2code.net";

    @Getter
    private static List<String> T2cPlugins = Arrays.asList(
            "T2CodeLib",
            "T2C-LuckyBox",
            "WonderBagShop",
            "CommandGUI",
            //   "T2C-OPSecurity",
            "OPSecurity",
            "PaPiTest",
            "T2C-Alias",
            "T2C-AutoResponse",
            "LoreEditor",
            "Booster",
            "AntiMapCopy",
            "AntiCopy",
            "T2C-LoginPermissionAuth"
    );

    @Getter
    private static final List<String> configT2CodeLogo = Arrays.asList(
            "# ╔═════════════════════════════════════════════════════════════════════════════╗",
            "# ║   _______   ___     _____               _                             _     ║",
            "# ║  |__   __| |__ \\   / ____|             | |                           | |    ║",
            "# ║     | |       ) | | |        ___     __| |   ___       _ __     ___  | |_   ║",
            "# ║     | |      / /  | |       / _ \\   / _` |  / _ \\     | '_ \\   / _ \\ | __|  ║",
            "# ║     | |     / /_  | |____  | (_) | | (_| | |  __/  _  | | | | |  __/ | |_   ║",
            "# ║     |_|    |____|  \\_____|  \\___/   \\__,_|  \\___| (_) |_| |_|  \\___|  \\__|  ║",
            "# ║                                                                             ║",
            "# ║                       This plugin is from T2Code.net                        ║",
            "# ║                      Development Team: JaTiTV & Jkobs                       ║",
            "# ║     Feel free to come to our Discord for support: https://dc.t2code.net     ║",
            "# ╚═════════════════════════════════════════════════════════════════════════════╝");

        //    "####################################################################################################################",
        //    "##                                                                                                                ##",
        //    "##        /$$$$$$$$ /$$$$$$   /$$$$$$                  /$$                                     /$$                ##",
        //    "##       |__  $$__//$$__  $$ /$$__  $$                | $$                                    | $$                ##",
        //    "##          | $$  |__/  \\ $$| $$  \\__/  /$$$$$$   /$$$$$$$  /$$$$$$      /$$$$$$$   /$$$$$$  /$$$$$$              ##",
        //    "##          | $$    /$$$$$$/| $$       /$$__  $$ /$$__  $$ /$$__  $$    | $$__  $$ /$$__  $$|_  $$_/              ##",
        //    "##          | $$   /$$____/ | $$      | $$  \\ $$| $$  | $$| $$$$$$$$    | $$  \\ $$| $$$$$$$$  | $$                ##",
        //    "##          | $$  | $$      | $$    $$| $$  | $$| $$  | $$| $$_____/    | $$  | $$| $$_____/  | $$ /$$            ##",
        //    "##          | $$  | $$$$$$$$|  $$$$$$/|  $$$$$$/|  $$$$$$$|  $$$$$$$ /$$| $$  | $$|  $$$$$$$  |  $$$$/            ##",
        //    "##          |__/  |________/ \\______/  \\______/  \\_______/ \\_______/|__/|__/  |__/ \\_______/   \\___/              ##",
        //    "##                                                                                                                ##",
        //    "##    T2CodeLib from JaTiTV / T2Code.net. In case of problems please contact the Discord: https://dc.t2code.net   ##",
        //    "##                                                                                                                ##",
        //    "####################################################################################################################");


    public static String[] getConfigLogo() {

        ArrayList<String> arrayList = new ArrayList<>(configT2CodeLogo);

        arrayList.addAll(Arrays.asList("", "# Spigot: " + getSpigot()));

        return arrayList.toArray(new String[0]);
    }

    @Getter
    private static String[] loadLogo = new String[]{
            "╔═══════════════════════════════════════════════════════════════════════════╗",
            "║<dark_red>  _______  <gray> ___  </gray>   _____               _                             _    </dark_red>║",
            "║<dark_red> |__   __| <gray>|__ \\ </gray>  / ____|             | |                           | |   </dark_red>║",
            "║<dark_red>    | |    <gray>   ) |</gray> | |        ___     __| |   ___       _ __     ___  | |_  </dark_red>║",
            "║<dark_red>    | |    <gray>  / / </gray> | |       / _ \\   / _` |  / _ \\     | '_ \\   / _ \\ | __| </dark_red>║",
            "║<dark_red>    | |    <gray> / /_ </gray> | |____  | (_) | | (_| | |  __/  _  | | | | |  __/ | |_  </dark_red>║",
            "║<dark_red>    |_|    <gray>|____|</gray>  \\_____|  \\___/   \\__,_|  \\___| (_) |_| |_|  \\___|  \\__| </dark_red>║",
            "║                                                                           ║",
            "║<color:#69b9ff>                      This plugin is from T2Code.net                       </color>║",
            "║<color:#69b9ff>                     Development Team: JaTiTV & Jkobs                      </color>║",
            "║<color:#69b9ff>    Feel free to come to our Discord for support: https://dc.t2code.net    </color>║",
            "╠═══════════════════════════════════════════════════════════════════════════╣"
    };

    @Getter
    private static final String pluginChannel_ProxyOnlinePlayers = "t2c:bonlp";
    @Getter
    private static final String pluginChannel_ProxyCommand = "t2c:bcmd";
    @Getter
    private static final String pluginChannel_CGUIOnlinePlayers = "t2c:cguiopl";
    @Getter
    private static final String pluginChannel_AutoResponse = "t2c:aresp";
    @Getter
    private static final String pluginChannel_OPSecurity = "t2c:opsec";
    @Getter
    private static final String pluginSubChannel_Console = "T2Cconsole";
}
